## openjpeg 1.3%2Bdfsg

=== CMakeLists.txt ===
# Main CMakeLists.txt to build the OpenJPEG project using CMake (www.cmake.org)
# Written by Mathieu Malaterre

# This CMake project will by default create a library called openjpeg
# But if you want to use this project within your own (CMake) project
# you will eventually like to prefix the library to avoid linking confusion
# For this purpose you can define a CMake var: OPENJPEG_NAMESPACE to whatever you like
# e.g.:
# SET(OPENJPEG_NAMESPACE "GDCMOPENJPEG")
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)

IF(NOT OPENJPEG_NAMESPACE)
  SET(OPENJPEG_NAMESPACE "OPENJPEG")
  SET(OPENJPEG_STANDALONE 1)
ENDIF(NOT OPENJPEG_NAMESPACE)
# In all cases:
STRING(TOLOWER ${OPENJPEG_NAMESPACE} OPENJPEG_LIBRARY_NAME)

PROJECT(${OPENJPEG_NAMESPACE} C)

# Do full dependency headers.
INCLUDE_REGULAR_EXPRESSION("^.*$")

#-----------------------------------------------------------------------------
# OPENJPEG version number, useful for packaging and doxygen doc:
SET(OPENJPEG_VERSION_MAJOR 1)
SET(OPENJPEG_VERSION_MINOR 3)
SET(OPENJPEG_VERSION_BUILD 0)
SET(OPENJPEG_VERSION
  "${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}.${OPENJPEG_VERSION_BUILD}")

# This setting of SOVERSION assumes that any API change
# will increment either the minor or major version number of openjpeg
SET(OPENJPEG_LIBRARY_PROPERTIES
  VERSION   "${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}.${OPENJPEG_VERSION_BUILD}"
  SOVERSION "${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}"
)


#-----------------------------------------------------------------------------
# OpenJPEG build configuration options.
OPTION(BUILD_SHARED_LIBS "Build OpenJPEG with shared libraries." OFF)

#-----------------------------------------------------------------------------
SET (EXECUTABLE_OUTPUT_PATH ${OPENJPEG_BINARY_DIR}/bin CACHE PATH "Single output directory for building all executables.")
SET (LIBRARY_OUTPUT_PATH ${OPENJPEG_BINARY_DIR}/bin CACHE PATH "Single output directory for building all libraries.")
MARK_AS_ADVANCED(LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH)


#-----------------------------------------------------------------------------
# For the codec...
OPTION(BUILD_EXAMPLES "Build the Examples (codec...)." OFF)


# configure name mangling to allow multiple libraries to coexist
# peacefully
IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/openjpeg_mangle.h.in)
SET(MANGLE_PREFIX ${OPENJPEG_LIBRARY_NAME})
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/openjpeg_mangle.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/openjpeg_mangle.h
               @ONLY IMMEDIATE)
ENDIF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/openjpeg_mangle.h.in)

#-----------------------------------------------------------------------------
# Always build the library
INCLUDE_DIRECTORIES(BEFORE ${CMAKE_CURRENT_BINARY_DIR})
SUBDIRS(
  libopenjpeg
  mj2
  # cmake 2.4.5 has poor java support
  #j2kviewer/src
  )

IF(NOT UNIX)
SUBDIRS(
  jpwl
  jp3d
  indexer_JPIP
  )
ENDIF(NOT UNIX)

#-----------------------------------------------------------------------------
# Build example only if requested
IF(BUILD_EXAMPLES)
  SUBDIRS(codec)
ENDIF(BUILD_EXAMPLES)

#-----------------------------------------------------------------------------
# For the documentation
OPTION(BUILD_DOCUMENTATION "Build the doxygen documentation" OFF)
IF(BUILD_DOCUMENTATION)
  SUBDIRS(doc)
ENDIF(BUILD_DOCUMENTATION)

#-----------------------------------------------------------------------------
# For openjpeg team if they ever want Dart+CMake
IF(OPENJPEG_STANDALONE)
  INCLUDE(Dart)
  MARK_AS_ADVANCED(BUILD_TESTING DART_ROOT TCL_TCLSH)
  IF(BUILD_TESTING)
    ENABLE_TESTING()
    SET(BUILDNAME "OpenJPEG-${CMAKE_SYSTEM}-${CMAKE_C_COMPILER}" CACHE STRING "Name of build on the dashboard")
    MARK_AS_ADVANCED(BUILDNAME)
  ENDIF(BUILD_TESTING)
ENDIF(OPENJPEG_STANDALONE)

# Adding test with dataset from:
# http://www.crc.ricoh.com/~gormish/jpeg2000conformance/
# http://www.jpeg.org/jpeg2000guide/testimages/testimages.html

#-----------------------------------------------------------------------------
# Adding JPEG2000_CONFORMANCE_DATA_ROOT
FIND_PATH(JPEG2000_CONFORMANCE_DATA_ROOT testimages.html
  ${OPENJPEG_SOURCE_DIR}/../jpeg2000testimages
  $ENV{JPEG2000_CONFORMANCE_DATA_ROOT}
)

#-----------------------------------------------------------------------------
# Compiler specific flags:
IF(CMAKE_COMPILER_IS_GNUCC)
  # For all builds, make sure openjpeg is std99 compliant:
  SET(CMAKE_C_FLAGS "-Wall -std=c99 ${CMAKE_C_FLAGS}")
  # Do not use ffast-math for all build, it would produce incorrect results, only set for release:
  SET(CMAKE_C_FLAGS_RELEASE "-ffast-math ${CMAKE_C_FLAGS_RELEASE}")
ENDIF(CMAKE_COMPILER_IS_GNUCC)

=== jpwl/CMakeLists.txt ===
# Makefile for the main JPWL OpenJPEG codecs: JPWL_ j2k_to_image and JPWL_image_to_j2k

ADD_DEFINITIONS(-DUSE_JPWL)

SET(OPJ_SRCS 
../libopenjpeg/bio.c 
../libopenjpeg/cio.c 
../libopenjpeg/dwt.c 
../libopenjpeg/event.c 
../libopenjpeg/image.c 
../libopenjpeg/j2k.c 
../libopenjpeg/j2k_lib.c 
../libopenjpeg/jp2.c 
../libopenjpeg/jpt.c 
../libopenjpeg/mct.c 
../libopenjpeg/mqc.c 
../libopenjpeg/openjpeg.c 
../libopenjpeg/pi.c 
../libopenjpeg/raw.c 
../libopenjpeg/t1.c 
../libopenjpeg/t2.c 
../libopenjpeg/tcd.c 
../libopenjpeg/tgt.c
)
SET(JPWL_SRCS crc.c jpwl.c jpwl_lib.c rs.c)

ADD_LIBRARY(openjpeg_JPWL ${JPWL_SRCS} ${OPJ_SRCS})

# Do the proper thing when building static...if only there was configured
# headers or def files instead
#IF(NOT BUILD_SHARED_LIBS)
#  ADD_DEFINITIONS(-DOPJ_STATIC)
#ENDIF(NOT BUILD_SHARED_LIBS)

INCLUDE_DIRECTORIES(
  ${OPENJPEG_SOURCE_DIR}/libopenjpeg
  )

FIND_PACKAGE(TIFF REQUIRED)

ADD_EXECUTABLE(JPWL_j2k_to_image
../codec/convert.c ../codec/j2k_to_image.c
)
TARGET_LINK_LIBRARIES(JPWL_j2k_to_image openjpeg_JPWL ${TIFF_LIBRARIES})
IF(UNIX)
  TARGET_LINK_LIBRARIES(JPWL_j2k_to_image m)
ENDIF(UNIX)

ADD_EXECUTABLE(JPWL_image_to_j2k
../codec/convert.c ../codec/image_to_j2k.c)
TARGET_LINK_LIBRARIES(JPWL_image_to_j2k openjpeg_JPWL ${TIFF_LIBRARIES})
IF(UNIX)
  TARGET_LINK_LIBRARIES(JPWL_image_to_j2k m)
ENDIF(UNIX)

## openjpeg 1.3+dfsg

=== Makefile ===
# Linux makefile for OpenJPEG

VER_MAJOR = 2
VER_MINOR = 1.3.0

SRCS = ./libopenjpeg/bio.c ./libopenjpeg/cio.c ./libopenjpeg/dwt.c ./libopenjpeg/event.c ./libopenjpeg/image.c ./libopenjpeg/j2k.c ./libopenjpeg/j2k_lib.c ./libopenjpeg/jp2.c ./libopenjpeg/jpt.c ./libopenjpeg/mct.c ./libopenjpeg/mqc.c ./libopenjpeg/openjpeg.c ./libopenjpeg/pi.c ./libopenjpeg/raw.c ./libopenjpeg/t1.c ./libopenjpeg/t2.c ./libopenjpeg/tcd.c ./libopenjpeg/tgt.c
INCLS = ./libopenjpeg/bio.h ./libopenjpeg/cio.h ./libopenjpeg/dwt.h ./libopenjpeg/event.h ./libopenjpeg/fix.h ./libopenjpeg/image.h ./libopenjpeg/int.h ./libopenjpeg/j2k.h ./libopenjpeg/j2k_lib.h ./libopenjpeg/jp2.h ./libopenjpeg/jpt.h ./libopenjpeg/mct.h ./libopenjpeg/mqc.h ./libopenjpeg/openjpeg.h ./libopenjpeg/pi.h ./libopenjpeg/raw.h ./libopenjpeg/t1.h ./libopenjpeg/t2.h ./libopenjpeg/tcd.h ./libopenjpeg/tgt.h ./libopenjpeg/opj_malloc.h ./libopenjpeg/opj_includes.h 
INCLUDE = -Ilibopenjpeg

# General configuration variables:
CC = gcc
AR = ar

PREFIX = /usr
INSTALL_LIBDIR = $(PREFIX)/lib
INSTALL_INCLUDE = $(PREFIX)/include

# Converts cr/lf to just lf
DOS2UNIX = dos2unix

COMPILERFLAGS = -Wall -O3 -ffast-math -std=c99 -fPIC
LIBRARIES = -lstdc++

MODULES = $(SRCS:.c=.o)
CFLAGS = $(COMPILERFLAGS) $(INCLUDE)

TARGET  = openjpeg
STATICLIB = lib$(TARGET).a
SHAREDLIB = lib$(TARGET)-$(VER_MAJOR).$(VER_MINOR).so
LIBNAME = lib$(TARGET).so.$(VER_MAJOR)



default: all

all: OpenJPEG

dist: OpenJPEG
	install -d dist
	install -m 644 $(STATICLIB) dist
	install -m 755 $(SHAREDLIB) dist
	ln -sf $(SHAREDLIB) dist/$(LIBNAME)
	install libopenjpeg/openjpeg.h dist

dos2unix:
	@$(DOS2UNIX) $(SRCS) $(INCLS)

OpenJPEG: $(STATICLIB) $(SHAREDLIB)

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

$(STATICLIB): $(MODULES)
	$(AR) r $@ $(MODULES)

$(SHAREDLIB): $(MODULES)
	$(CC) -s -shared -Wl,-soname,$(LIBNAME) -o $@ $(MODULES) $(LIBRARIES)

install: OpenJPEG
	install -d '$(DESTDIR)$(INSTALL_LIBDIR)' '$(DESTDIR)$(INSTALL_INCLUDE)'
	install -m 644 -o root -g root $(STATICLIB) '$(DESTDIR)$(INSTALL_LIBDIR)'
	ranlib '$(DESTDIR)$(INSTALL_LIBDIR)/$(STATICLIB)'
	install -m 755 -o root -g root $(SHAREDLIB) '$(DESTDIR)$(INSTALL_LIBDIR)'
	ln -sf $(SHAREDLIB) '$(DESTDIR)$(INSTALL_LIBDIR)/$(LIBNAME)'
	install -m 644 -o root -g root libopenjpeg/openjpeg.h '$(DESTDIR)$(INSTALL_INCLUDE)'
	-ldconfig

clean:
	rm -rf core dist/ u2dtmp* $(MODULES) $(STATICLIB) $(SHAREDLIB) $(LIBNAME)

osx:
	make -f Makefile.osx

osxinstall:
	make -f Makefile.osx install

osxclean:
	make -f Makefile.osx clean

=== JavaOpenJPEG/CMakeLists.txt ===
# Build the demo app, small examples

# First thing define the common source:
SET(common_SRCS
  convert.c
  )
# Then check if getopt is present:
INCLUDE (${CMAKE_ROOT}/Modules/CheckIncludeFile.cmake)
SET(DONT_HAVE_GETOPT 1)
IF(UNIX) #I am pretty sure only *nix sys have this anyway
  CHECK_INCLUDE_FILE("getopt.h" CMAKE_HAVE_GETOPT_H)
  # Seems like we need the contrary:
  IF(CMAKE_HAVE_GETOPT_H)
    SET(DONT_HAVE_GETOPT 0)
  ENDIF(CMAKE_HAVE_GETOPT_H)
ENDIF(UNIX)

# If not getopt was found then add it to the lib:
IF(DONT_HAVE_GETOPT)
  ADD_DEFINITIONS(-DDONT_HAVE_GETOPT)
  SET(common_SRCS
    ${common_SRCS}
    compat/getopt.c
  )
ENDIF(DONT_HAVE_GETOPT)


# Headers file are located here:
INCLUDE_DIRECTORIES(
  ${OPENJPEG_SOURCE_DIR}/libopenjpeg
  )

# Do the proper thing when building static...if only there was configured
# headers or def files instead
IF(NOT BUILD_SHARED_LIBS)
  ADD_DEFINITIONS(-DOPJ_STATIC)
ENDIF(NOT BUILD_SHARED_LIBS)

FIND_PACKAGE(TIFF REQUIRED)

# Loop over all executables:
FOREACH(exe j2k_to_image image_to_j2k)
  ADD_EXECUTABLE(${exe} ${exe}.c ${common_SRCS})
  TARGET_LINK_LIBRARIES(${exe} ${OPJ_PREFIX}openjpeg ${TIFF_LIBRARIES})
  # On unix you need to link to the math library:
  IF(UNIX)
    TARGET_LINK_LIBRARIES(${exe} -lm)
  ENDIF(UNIX)
  # Install exe
  INSTALL_TARGETS(/bin/ ${exe})
ENDFOREACH(exe)

=== JavaOpenJPEG/Makefile ===
# Makefile for the main OpenJPEG codecs: j2k_to_image and image_to_j2k

CFLAGS = -O3 -lstdc++ # -g -p -pg

all: j2k_to_image image_to_j2k

j2k_to_image: j2k_to_image.c ../libopenjpeg.a
	gcc $(CFLAGS) compat/getopt.c convert.c j2k_to_image.c -o j2k_to_image -L.. -lopenjpeg -I ../libopenjpeg/ -lm -ltiff

image_to_j2k: image_to_j2k.c ../libopenjpeg.a
	gcc $(CFLAGS) compat/getopt.c convert.c image_to_j2k.c -o image_to_j2k -L.. -lopenjpeg -I ../libopenjpeg/ -lm -ltiff

clean:
	rm -f j2k_to_image image_to_j2k

=== OPJViewer/Makefile ===
# Makefile for OPJViewer

# General configuration variables:
CC = $(shell wx-config-2.8 --cxx)
AR = ar

CFLAGS = -DUSE_JPWL -DwxUSE_LIBOPENJPEG -DwxUSE_GUI=1 -DOPJ_STATIC -DOPJ_HTMLABOUT $(shell wx-config-2.8 --cxxflags) # -g -p -pg -DUSE_JPWL

OPJV_SRCS = source/imagj2k.cpp source/imagmj2.cpp source/wxj2kparser.cpp source/imagjp2.cpp source/OPJViewer.cpp source/wxjp2parser.cpp source/OPJViewer.cpp source/OPJThreads.cpp

MODULES = $(OPJV_SRCS:.cpp=.o)

all: opjviewer lib

.cpp.o:
	$(CC) $(CFLAGS) -c $< -o $@

lib:
	cd ../jpwl; make

opjviewer: $(OPJV_SRCS) lib
        $(CC) $(CFLAGS) -I .. $(OPJV_SRCS) -o OPJViewer -L ../jpwl -lopenjpeg_JPWL -lm -lstdc++ -ltiff $(shell wx-config-2.8 --libs)


clean:
	rm -f OPJViewer *.o *.a
	cd ../libopenjpeg; rm -f *.o




#.cpp.o :
#       $(CXX) -g -c `wx-config-2.8 --cxxflags` -I ../.. -D wxUSE_LIBOPENJPEG -D wxHACK_BOOLEAN -o $@ $<

#all:    $(PROGRAM)

#$(PROGRAM):     $(OBJECTS)
#       $(CXX) -o $(PROGRAM) $(OBJECTS) -lopenjpeg -L ../.. `wx-config-2.8 --libs`

#clean:
#       rm -f *.o $(PROGRAM)

=== codec/CMakeLists.txt ===
# Build the demo app, small examples

# First thing define the common source:
SET(common_SRCS
  convert.c
  index.c
)

# Then check if getopt is present:
INCLUDE (${CMAKE_ROOT}/Modules/CheckIncludeFile.cmake)
SET(DONT_HAVE_GETOPT 1)
IF(UNIX) #I am pretty sure only *nix sys have this anyway
  CHECK_INCLUDE_FILE("getopt.h" CMAKE_HAVE_GETOPT_H)
  # Seems like we need the contrary:
  IF(CMAKE_HAVE_GETOPT_H)
    SET(DONT_HAVE_GETOPT 0)
  ENDIF(CMAKE_HAVE_GETOPT_H)
ENDIF(UNIX)

# If not getopt was found then add it to the lib:
IF(DONT_HAVE_GETOPT)
  ADD_DEFINITIONS(-DDONT_HAVE_GETOPT)
  SET(common_SRCS
    ${common_SRCS}
    compat/getopt.c
  )
ENDIF(DONT_HAVE_GETOPT)

# Headers file are located here:
INCLUDE_DIRECTORIES(
  ${OPENJPEG_SOURCE_DIR}/libopenjpeg
  )

# Do the proper thing when building static...if only there was configured
# headers or def files instead
IF(NOT BUILD_SHARED_LIBS)
  ADD_DEFINITIONS(-DOPJ_STATIC)
ENDIF(NOT BUILD_SHARED_LIBS)

FIND_PACKAGE(TIFF REQUIRED)

# Loop over all executables:
FOREACH(exe j2k_to_image image_to_j2k)
  ADD_EXECUTABLE(${exe} ${exe}.c ${common_SRCS})
  TARGET_LINK_LIBRARIES(${exe} ${OPJ_PREFIX}openjpeg ${TIFF_LIBRARIES})
  ADD_TEST(${exe} ${EXECUTABLE_OUTPUT_PATH}/${exe})
  # calling those exe without option will make them fail always:
  SET_TESTS_PROPERTIES(${exe} PROPERTIES WILL_FAIL TRUE)
  # On unix you need to link to the math library:
  IF(UNIX)
    TARGET_LINK_LIBRARIES(${exe} m)
  ENDIF(UNIX)
  # Install exe
  INSTALL_TARGETS(/bin/ ${exe})
ENDFOREACH(exe)

# Do testing here, once we know the examples are being built:
FILE(GLOB_RECURSE OPENJPEG_DATA_IMAGES_GLOB
  "${JPEG2000_CONFORMANCE_DATA_ROOT}/*.j2k"
  "${JPEG2000_CONFORMANCE_DATA_ROOT}/*.j2c"
  "${JPEG2000_CONFORMANCE_DATA_ROOT}/*.jp2"
  )

FOREACH(filename ${OPENJPEG_DATA_IMAGES_GLOB})
  GET_FILENAME_COMPONENT(filename_temp ${filename} NAME)
  ADD_TEST(j2i-${filename_temp} ${EXECUTABLE_OUTPUT_PATH}/j2k_to_image -i ${filename} -o ${filename_temp}.tif)
ENDFOREACH(filename)

=== codec/Makefile ===
# Makefile for the main OpenJPEG codecs: j2k_to_image and image_to_j2k

CFLAGS = -O3 -lstdc++ # -g -p -pg

all: j2k_to_image image_to_j2k

j2k_to_image: j2k_to_image.c ../libopenjpeg.a
	gcc $(CFLAGS) compat/getopt.c index.c convert.c j2k_to_image.c -o j2k_to_image -L.. -lopenjpeg -I ../libopenjpeg/ -lm -ltiff

image_to_j2k: image_to_j2k.c ../libopenjpeg.a
	gcc $(CFLAGS) compat/getopt.c index.c convert.c image_to_j2k.c -o image_to_j2k -L.. -lopenjpeg -I ../libopenjpeg/ -lm -ltiff

clean:
	rm -f j2k_to_image image_to_j2k

=== doc/CMakeLists.txt ===
FIND_PACKAGE(Doxygen REQUIRED)

# The Doxyfile.dox is poorly defined and produce output
# in the source dir
ADD_CUSTOM_TARGET(doxygen
# By default doxygen target is added to the 'all' target. Project is small
# thus running doxygen is not too time consuming
  ALL
  ${DOXYGEN}
  ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.dox
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

=== jp3d/CMakeLists.txt ===
# Linux makefile for OpenJPEG

#VER_MAJOR = 1
#VER_MINOR = 0.0

SUBDIRS(
  libjp3dvm
  codec
)

=== jp3d/Makefile ===
# Linux makefile for OpenJPEG

VER_MAJOR = 1
VER_MINOR = 0.0

SRCS = ./libopenjpeg/bio.c ./libopenjpeg/cio.c ./libopenjpeg/dwt.c ./libopenjpeg/event.c ./libopenjpeg/image.c ./libopenjpeg/j2k.c ./libopenjpeg/j2k_lib.c ./libopenjpeg/jp2.c ./libopenjpeg/jpt.c ./libopenjpeg/mct.c ./libopenjpeg/mqc.c ./libopenjpeg/openjpeg.c ./libopenjpeg/pi.c ./libopenjpeg/raw.c ./libopenjpeg/t1.c ./libopenjpeg/t2.c ./libopenjpeg/tcd.c ./libopenjpeg/tgt.c
INCLS = ./libopenjpeg/bio.h ./libopenjpeg/cio.h ./libopenjpeg/dwt.h ./libopenjpeg/event.h ./libopenjpeg/fix.h ./libopenjpeg/image.h ./libopenjpeg/int.h ./libopenjpeg/j2k.h ./libopenjpeg/j2k_lib.h ./libopenjpeg/jp2.h ./libopenjpeg/jpt.h ./libopenjpeg/mct.h ./libopenjpeg/mqc.h ./libopenjpeg/openjpeg.h ./libopenjpeg/pi.h ./libopenjpeg/raw.h ./libopenjpeg/t1.h ./libopenjpeg/t2.h ./libopenjpeg/tcd.h ./libopenjpeg/tgt.h ./libopenjpeg/opj_includes.h
INCLUDE = -Ilibopenjpeg

# General configuration variables:
CC = gcc
AR = ar

INSTALLDIR = /usr/lib

# Converts cr/lf to just lf
DOS2UNIX = dos2unix

COMPILERFLAGS = -O3
LIBRARIES = -lstdc++

MODULES = $(SRCS:.c=.o)
CFLAGS = $(COMPILERFLAGS) $(INCLUDE)

TARGET  = openjpeg
STATICLIB = lib$(TARGET).a
SHAREDLIB = lib$(TARGET)-$(VER_MAJOR).$(VER_MINOR).so
LIBNAME = lib$(TARGET).so.$(VER_MAJOR)



default: all

all: dist

dist: OpenJPEG
	mkdir dist
	cp *.a dist/
	cp *.so dist/
	cp libopenjpeg/openjpeg.h dist/

dos2unix:
	@$(DOS2UNIX) $(SRCS) $(INCLS)

OpenJPEG: $(STATICLIB) $(SHAREDLIB)

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

$(STATICLIB): $(MODULES)
	$(AR) r $@ $(MODULES)

$(SHAREDLIB): $(MODULES)
	$(CC) -s -shared -Wl,-soname,$(LIBNAME) -o $@ $(MODULES) $(LIBRARIES)

install:
	install -m 644 -o root -g root $(STATICLIB) $(INSTALLDIR)
	install -m 755 -o root -g root $(SHAREDLIB) $(INSTALLDIR)
	ln -sf $(SHAREDLIB) $(INSTALLDIR)/$(LIBNAME)
	ldconfig

clean:
	rm -rf core dist/ u2dtmp* $(MODULES) $(STATICLIB) $(SHAREDLIB) $(LIBNAME)

osx:
	make -f Makefile.osx

osxinstall:
	make -f Makefile.osx install

osxclean:
	make -f Makefile.osx clean

=== libopenjpeg/CMakeLists.txt ===
INCLUDE_REGULAR_EXPRESSION("^.*$")
# Defines the source code for the library
SET(OPENJPEG_SRCS
  bio.c
  cio.c
  dwt.c
  event.c
  image.c
  j2k.c
  j2k_lib.c
  jp2.c
  jpt.c
  mct.c
  mqc.c
  openjpeg.c
  pi.c
  raw.c
  t1.c
  t2.c
  tcd.c
  tgt.c
)

# Pass proper definition to preprocessor to generate shared lib
IF(WIN32)
  IF(BUILD_SHARED_LIBS)
    ADD_DEFINITIONS(-DOPJ_EXPORTS)
  ELSE(BUILD_SHARED_LIBS)
    ADD_DEFINITIONS(-DOPJ_STATIC)
  ENDIF(BUILD_SHARED_LIBS)
ENDIF(WIN32)

# Create the library
ADD_LIBRARY(${OPENJPEG_LIBRARY_NAME} ${OPENJPEG_SRCS})
SET_TARGET_PROPERTIES(${OPENJPEG_LIBRARY_NAME} PROPERTIES
	${OPENJPEG_LIBRARY_PROPERTIES})

# Install library
INSTALL(TARGETS ${OPENJPEG_LIBRARY_NAME}
	DESTINATION lib)

# Install includes files
INSTALL(FILES openjpeg.h
	DESTINATION ${INCLUDE_INSTALL_DIR}/openjpeg)

=== mj2/CMakeLists.txt ===
# Makefile for the MJ2 codecs of the OpenJPEG library: frames_to_mj2, mj2_to_frames, extract_j2k_from_mj2 and wrap_j2k_in_mj2

# Headers file are located here:
INCLUDE_DIRECTORIES(
  ${OPENJPEG_SOURCE_DIR}/libopenjpeg
  )

ADD_EXECUTABLE(frames_to_mj2
  frames_to_mj2.c
  compat/getopt.c 
  mj2_convert.c mj2.c )
TARGET_LINK_LIBRARIES(frames_to_mj2 ${OPJ_PREFIX}openjpeg)
IF(UNIX)
  TARGET_LINK_LIBRARIES(frames_to_mj2 m)
ENDIF(UNIX)

ADD_EXECUTABLE(mj2_to_frames
    mj2_to_frames.c
    compat/getopt.c mj2_convert.c mj2.c )
TARGET_LINK_LIBRARIES(mj2_to_frames ${OPJ_PREFIX}openjpeg)
IF(UNIX)
  TARGET_LINK_LIBRARIES(mj2_to_frames m)
ENDIF(UNIX)

ADD_EXECUTABLE(extract_j2k_from_mj2
    extract_j2k_from_mj2.c
    mj2.c )
TARGET_LINK_LIBRARIES(extract_j2k_from_mj2 ${OPJ_PREFIX}openjpeg)
IF(UNIX)
  TARGET_LINK_LIBRARIES(extract_j2k_from_mj2 m)
ENDIF(UNIX)

ADD_EXECUTABLE(wrap_j2k_in_mj2
    wrap_j2k_in_mj2.c
    mj2.c )
TARGET_LINK_LIBRARIES(wrap_j2k_in_mj2 ${OPJ_PREFIX}openjpeg)
IF(UNIX)
  TARGET_LINK_LIBRARIES(wrap_j2k_in_mj2 m)
ENDIF(UNIX)

INSTALL(TARGETS frames_to_mj2 mj2_to_frames extract_j2k_from_mj2 wrap_j2k_in_mj2
	DESTINATION bin)

=== mj2/Makefile ===
# Makefile for the MJ2 codecs of the OpenJPEG library: frames_to_mj2, mj2_to_frames, extract_j2k_from_mj2 and wrap_j2k_in_mj2

CFLAGS = -O3 -lstdc++ # -g -p -pg

all: frames_to_mj2 mj2_to_frames extract_j2k_from_mj2 wrap_j2k_in_mj2

frames_to_mj2: frames_to_mj2.c ../libopenjpeg.a
	gcc $(CFLAGS) compat/getopt.c mj2_convert.c mj2.c frames_to_mj2.c -o frames_to_mj2 -L.. -lopenjpeg -I ../libopenjpeg/ -lm

mj2_to_frames: mj2_to_frames.c ../libopenjpeg.a
	gcc $(CFLAGS) compat/getopt.c mj2_convert.c mj2.c mj2_to_frames.c -o mj2_to_frames -L.. -lopenjpeg -I ../libopenjpeg/ -lm

extract_j2k_from_mj2: extract_j2k_from_mj2.c ../libopenjpeg.a
	gcc $(CFLAGS) mj2.c extract_j2k_from_mj2.c -o extract_j2k_from_mj2 -L.. -lopenjpeg -I ../libopenjpeg/ -lm

wrap_j2k_in_mj2: wrap_j2k_in_mj2.c ../libopenjpeg.a
	gcc $(CFLAGS) mj2.c wrap_j2k_in_mj2.c -o wrap_j2k_in_mj2 -L.. -lopenjpeg -I ../libopenjpeg/ -lm

clean:
	rm -f frames_to_mj2 mj2_to_frames extract_j2k_from_mj2 wrap_j2k_in_mj2

## openjpeg 1.5.0

=== debian/changelog ===
openjpeg (1.5.0-2precise0~ppa) precise; urgency=high

  * Adding libopenjpeg-java. Closes: #510443
  * Update d/control so that it is easier to backport to stable
  * Provide a fix for cmake commit a2be068c
  * Provide a symlinks openjpeg.h -> openjpeg-1.5/openjpeg.h for easier
    transition
  * Add openjpip-server package: openjpip-server
   - Add init script
   - Fix default location of tempfile to be in /tmp
  * Add openjpip java based clients packages:
   - openjpip-viewer
   - openjpip-viewer-xerces

 -- Otto Meier <otto@kesselgulasch.org>  Sat, 21 Dec 2013 19:02:07 +0100

openjpeg (1.5.0-1) experimental; urgency=low

  [ Robin Cornelius ]
  * Include motion j2k codec in build
    - Implement man pages for the mj2 tools
    - Use clean target of mj2/Makefile when running the debian/rules clean
      target
    - Update build patch, to set gcc options for mj2 Makefile based on the
      settings in debian/rules
  * Add ${misc:Depends} to binary packages
  * Place -dbg package in section debug

  [ David Paleino ]
  * New upstream version (Closes: #659226)
    - fix alpha channel encode by preventing an overrun in the static MCT
      tables when processing more than 3 color components. (Closes: #541807)
  * Package moved to "3.0 (quilt)" source format
  * Patches converted from dpatch to quilt-format
  * Dropped unapplicable patches with the new sources
  * Updated debian/copyright (missing bits and DEP-5)
  * Added README.source explaining the reason for repacking the tarball
  * Removed obsolete README.Debian
  * Bumped Standards-Version to 3.9.3
  * Dropped debian/image_to_j2k.pod and j2k_to_image.pod, upstream has
    proper manpages now
  * Updated Build-Dependencies and various small things in d/control

  [ Mathieu Malaterre ]
  * Add myself to uploaders
  * Switch to cmake buildsystem
  * Update orig-tar.sh to remove thirdparty/* files
  * Bump SONAME to 5 as per upstream recommendation
  * Install JPWL libraries (update *.symbols file)
  * Import two patches from upstream svn:
   - Add explicit link to math lib (-lm)
   - Fix SONAME handling in 1.5.0 (import from 1.5 branch)
  * Switch to dh(9), make multi-arch. Closes: #663045

 -- Mathieu Malaterre <malat@debian.org>  Mon, 16 Apr 2012 16:01:13 +0200

openjpeg (1.3+dfsg-4) unstable; urgency=high

  * Fix FTBFS on alpha for real (Closes: #483048).
     - Update 32_fix_FTBFS_on_alpha.dpatch with the patch provided by
       Arthur Loiret (thanks).
  * Set urgency to “high” for RC bugfix.

 -- Cyril Brulebois <kibi@debian.org>  Mon, 09 Mar 2009 16:59:02 +0100

openjpeg (1.3+dfsg-3) unstable; urgency=low

  * Fix FTBFS on alpha. Modify codec/dirent.h to not generate error if __linux__
    is defined as well as __alpha__. (Closes: #483048)

 -- Robin Cornelius <robin.cornelius@gmail.com>  Sun, 08 Jun 2008 06:48:24 +0200

openjpeg (1.3+dfsg-2) unstable; urgency=low

  * Fix FTBFS when “sudo” is used (which is the case on alpha, mips, and
    mipsel buildds) by using chmod in a better way, recursively removing
    -x and adding +X, so that sufficient permissions remain.
  * debian/control:
     - Add myself to Uploaders.
  * debian/copyright:
     - Update my mail address.

 -- Cyril Brulebois <kibi@debian.org>  Tue, 29 Apr 2008 08:23:56 +0200

openjpeg (1.3+dfsg-1) unstable; urgency=low

  [ Cyril Brulebois ]
  * Remove leftover codec/{image_to_j2k, j2k_to_image} in the clean
    target (fix double-build failure)
  * Indent list in the long description (per lintian)
  * Replace XS-Vcs-{Svn, Browser} with Vcs-{Git, Browser}
  * Nuke trailing whitespaces.
  * Rephrase descriptions.
  * Remove remaining trailing whitespaces.
  * Use “$(MAKE) dist” instead of “make dist”.
  * Move .PHONY and .SUFFIXES to the bottom.
  * Use an include of dpatch.make instead of defining the rules
    manually.
  * Remove unneeded get-orig-source target and the mode line.
  * Try and adjust permissions during “clean” since upstream ships
    everything with a+x.
  * Rename manpages to build-manpages, adjust .PHONY.
  * Remove extra (no longer needed with recent dpkg-dev versions) -L and
    -l flags from dh_shlibdeps.
  * Nuke trailing whitespaces in copyright file.
  * Document in debian/TODO that the hardcoded shared object symlinks is a
    target for further uploads.

  [ Robin Cornelius ]
  * Build codec tools against system libtiff headers.
  * Remove non-dfsg files from package and edit copyright and README.Debian to
    document changes and removals.
  * Tidy up control file package descriptions and use soname in -dbg
    package
  * Do not keep upstream source in our git tree. We should use a get-
    orig-source
  * Apply Cyril Brulebois' suggestion for watchfile regex.
  * Update debian/rules. Note get-orig-source needs further work.
  * Change maintainer address to be the group address.
  * Fix build warning, add final new line to debian/watch.
  * Fix lintian warnings due to different email address in changelog and
    Uploaders:
  * In debian/rules clean target, use dh_clean to remove all files,
    don't use rm
  * Update debian/copyright as I have made changes in 2008.
  * Switch from txt2man to perlpod:
     - txt2man is buggy and generates incorrectly formatted man pages
       (#416391).
     - Remove it from Build-Depends.
     - Use perlpod manpages (debian/*.pod).
     - Generate manpages during the build through pod2man.
     - Delete them through dh_clean.

 -- Robin Cornelius <robin.cornelius@gmail.com>  Wed, 19 Mar 2008 10:59:56 +0000

openjpeg (1.3-1) unstable; urgency=low

  * New upstream release
    - Drop SVN merge patch as v1.3 contains all required fixes.
    - Update debian/rules to match upstream changes to makefile.
    - Stop ignoring make errors and rm errors in debian/rules.
    - Fix build environment via dpatch to use -O0 or -O3 when requested, use -g
      to build library and strip via dh_strip and build codecs against shared
      not static library.


=== debian/control ===
Source: openjpeg
Priority: extra
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders:
 Robin Cornelius <robin.cornelius@gmail.com>
 , David Bremner <bremner@debian.org>
 , David Paleino <dapal@debian.org>
 , Mathieu Malaterre <malat@debian.org>
Homepage: http://www.openjpeg.org
Build-Depends:
 debhelper (>= 9)
 , cmake (>= 2.8.0)
 , javahelper (>= 0.37~)
 , default-jdk
 , libxerces2-java
 , libtiff5-dev | libtiff-dev
 , libpng-dev
 , liblcms2-dev
 , zlib1g-dev
 , libfcgi-dev
 , libcurl4-gnutls-dev | libcurl-ssl-dev
 , doxygen
Standards-Version: 3.9.3
Section: libs
Vcs-Browser: http://git.debian.org/?p=pkg-phototools/openjpeg.git
Vcs-Git: git://git.debian.org/git/pkg-phototools/openjpeg.git

Package: libopenjpeg-dev
Section: libdevel
Architecture: any
Depends:
 libopenjpeg5 (= ${binary:Version})
 , ${misc:Depends}
Description: development files for OpenJPEG, a JPEG 2000 image library
 OpenJPEG is a library for handling the JPEG 2000 image compression format.
 JPEG 2000 is a wavelet-based image compression standard and permits progressive
 transmission by pixel and resolution accuracy for progressive downloads of an
 encoded image. It supports lossless and lossy compression, supports higher
 compression than JPEG 1991, and has resilience to errors in the image.

Package: libopenjpeg5
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}
 , ${misc:Depends}
Description: JPEG 2000 image compression/decompression library
 OpenJPEG is a library for handling the JPEG 2000 image compression format.

Package: libopenjpeg-java
Section: java
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${java:Depends}
Description: java bindings for libopenjpeg, a JPEG 2000 image library
 This package contains the java binding to match the runtime component of the
 OpenJPEG library, allowing java program to use OpenJPEG.

Package: libopenjpeg5-dbg
Section: debug
Architecture: any
Depends: libopenjpeg5 (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for libopenjpeg5, a JPEG 2000 image library
 This package contains the debug symbols to match the runtime component of the
 OpenJPEG library, allowing debugging of a program using OpenJPEG to
 access debugging details within the library itself.

Package: openjpip-dec-server
Section: graphics
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to allow caching of JPEG 2000 files using JPIP protocol
 This is client side application for caching remote JPEG 2000 using the JPIP
 protocol. This command line application needs to run on the client side to
 allow application such as opj_viewer or opj_viewer_xerces to view images.

Package: openjpip-viewer-xerces
Section: graphics
Architecture: any
Depends: ${misc:Depends}, ${java:Depends}, openjpip-dec-server
Description: JPEG 2000 java based viewer for advanced remote JPIP access
 Java based client to view remote JPEG 2000 using JPIP protocol.
 This is a simple java viewer to allow:
 .
  - Scale up request: Enlarge the window
  - ROI request: Select a region by mouse click and drag, then click inside the
    red frame of the selected region
  - Annotate image with ROI information in XML metadata: Click button "Region
    Of Interest"
  - Open a new window presenting an aligned image with a locally stored image:
    Click button "Image Registration" (Under Construction)

Package: openjpip-viewer
Section: graphics
Architecture: any
Depends: ${misc:Depends}, ${java:Depends}, openjpip-dec-server
Description: JPEG 2000 java based viewer for basic remote JPIP access
 Java based client to view remote JPEG 2000 using JPIP protocol.
 This is a simple java viewer to allow:
 .
  - Scale up request: Enlarge the window
  - ROI request: Select a region by mouse click and drag, then click inside the
    red frame of the selected region

Package: openjpip-server
Section: graphics
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libwww-perl, apache2.2-bin, spawn-fcgi (>= 1.6.1)
Description: JPIP server for JPEG 2000 files
 OpenJPIP software is an implementation of JPEG 2000 Part9: Interactivity tools,
 APIs and protocols (JPIP). For more info about JPIP, check the website:
 http://www.jpeg.org/jpeg2000/j2kpart9.html. The current implementation uses
 some results from the 2KAN project (http://www.2kan.org).
 .
 First Version 1.0 covers:
 .
  - JPT-stream (Tile based) and JPP-stream (Precinct based) media types
  - Session, channels, cache model managements
  - JPIP over HTTP
  - Indexing JPEG 2000 files
  - Embedding XML formatted metadata
  - Region Of Interest (ROI) requests


Package: openjpeg-tools
Section: graphics
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: command-line tools using the JPEG 2000 library
 This package provides with command-line tools allowing for conversions between
 several formats and also provides tools for encoding and decoding
 motion-jpeg2000 video formats:
 .
  - j2k_to_image: decodes j2k, jp2, and jpt files to pgm, ppm, pnm,
                  pgx, and bmp.
  - image_to_j2k: encodes pnm, pgm, pgx, bmp, and ppm files to j2k,
                  and jp2.
  - index_create: create jp2 with JPIP index file from a j2k file.
  - frames_to_mj2: convert YUV video streams to mj2 format.
  - mj2_to_frames: convert mj2 video streams to YUV format.
  - wrap_j2k_in_mj2: wrap j2k codestreams into mj2 format.
  - extract-j2k-from_mj2: extract j2k codestreams from the mj2 format.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CURVER := $(shell dpkg-parsechangelog | grep ^Version | awk '{print $$2}' | cut -d- -f1 | cut -d+ -f1)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
JAVA_HOME=/usr/lib/jvm/default-java

%:
	dh $@ --buildsystem=cmake --parallel --with javahelper

CMAKE_EXTRA_FLAGS += -DCMAKE_SKIP_RPATH=ON \
	-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
	-DOPENJPEG_INSTALL_LIB_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
	-DBUILD_CODEC:BOOL=ON \
	-DBUILD_JPIP:BOOL=ON \
	-DBUILD_JPIP_SERVER:BOOL=ON \
	-DBUILD_JPWL:BOOL=ON \
	-DBUILD_JAVA:BOOL=ON \
	-DBUILD_MJ2:BOOL=ON \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_TESTING:BOOL=OFF \
	-DBUILD_THIRDPARTY:BOOL=OFF

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)
	# technically a java module should not need a SONAME, use a trick from python module+cmake
	# http://lists.debian.org/debian-python/2012/04/msg00059.html
	sed -i -e 's/ -Wl,-soname,[^ ]\+ / /' obj-*/applications/JavaOpenJPEG/CMakeFiles/openjpegjni.dir/link.txt

override_dh_strip:
	dh_strip --dbg-package=libopenjpeg5-dbg

override_dh_install:
	dh_install --list-missing

override_dh_installinit:
	dh_installinit -popenjpip-server --name=openjpip

# http://cmake.org/gitweb?p=cmake.git;a=commitdiff;h=a2be068c
override_dh_auto_install:
	sed -i -e "s/FATAL_ERROR/STATUS/g" ./obj-*/CMakeFiles/Export/lib/*/openjpeg-1.5/OpenJPEGTargets-relwithdebinfo.cmake
	dh_auto_install

get-orig-source:
	uscan --verbose \
		--force-download \
		--download-version $(CURVER)

.PHONY: override_dh_auto_configure \
	override_dh_strip \
	get-orig-source

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3
http://code.google.com/p/openjpeg/downloads/list?can=1 \
		       .*/openjpeg-([0-9_.]+)\.tar\.gz \
debian debian/orig-tar.sh
